import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class BINDITC_to_C extends Frame implements ActionListener
 { 
    private TextField channels_chosen,ports_chosen;
    private Choice select_port,select_channel;
    private RandomAccessFile ip_file,load_ips,processor_file,load_processors;
    private String ip_name_string,processor_name_string,selected,to_be_deleted;
    private ip_record ip_record;
    private File lip,ipf;
    private int count1,position1,i,temp,j;
    private Label l0,l1,l2,l3;
    private Button Bind,Close;
    protected TtoC_binding_class ttoc_object;
    private TtoC_binding_Node ttob;
    private String total1,total2,selected_task;
    private Module_List m_list;
    private Module_Node fnode;
    private boolean ips;
    private int[] channels,ports;
    
   
 
   public BINDITC_to_C( Module_List m_list,TtoC_binding_class ttoc_object,String selected_task,String selected_component,int[] channels,int[] ports)
   {
     super ("Bind a task's channels to component ports.");
     this.m_list = m_list;
     this.selected_task = selected_task;
   //  ports = new int[10];
     //channels = new int[10];
     this.ports=ports;
     this.channels=channels;
     this.ttoc_object=ttoc_object;
     ip_record = new ip_record();
     select_port= new Choice();
     ports_chosen = new TextField(5);
     select_channel = new Choice();
     channels_chosen = new TextField(5);
     ports_chosen.setEditable(false);
     channels_chosen.setEditable(false);
     
     setLayout(new  GridLayout(6,2,10,15));
     l1 = new Label("Already chosen Channels for t his Task");
     l0 = new Label ("Choose a channel:");
     l2 = new  Label("Choose a port");
     l3 = new Label("Already chosen Ports of this component:");

     Bind = new Button("Bind");
     Close = new Button("Close");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);

   /* Get the max ports and max channels */

      total1 = "";
      total2 = "";
      i=1;
      ips=false;
      lip = new File("load_ips");
      ipf = new File("ip_file");
          try                                                    
           {
             if(lip.exists()&&(ipf.length()> 4))
              {
               System.out.println("Load_IPs exists");
               ip_file = new RandomAccessFile("load_ips", "rw");
               count1 = ip_file.readInt();
               position1=ip_file.readInt(); /* This is the position in the file, where to add this record. */             
               System.out.println("The read position is" + position1);
              }
             else
              {
               System.out.println("Load_IPs does not exist");
               ip_file = new RandomAccessFile("load_ips", "rw");
               ip_file.writeInt(0); /* Set count to 0 */
               position1 = -1; /* next position to write in the memory_file will be 0 */
              }
              if(ipf.exists())
              {
                ip_file = new RandomAccessFile("ip_file", "rw");
              }
              else
              {
               System.out.println("Sorry, the library doesn't exist, \nCould not load IPs");
               position1 = -1;
               ip_file = new RandomAccessFile("ip_file", "rw");
              }
           }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
               System.exit(1);
           }

      try
      { 
       for(int k=count1; k<=position1;k++)
        {
          System.out.println("Test point");
          ip_file.seek((long) k*(ip_class.object_size));
          ip_record.read(ip_file);
          System.out.println("Test point 2");
          if(selected_component.equals(ip_record.getIdentifier().trim()))
           {
             temp=(int)ip_record.getPorts();
             for(j=1;j<=temp;j++)
             {
               select_port.add(""+j);
               System.out.println("The added port is"+j);
             }
             ports[0]=(int)ip_record.getPorts();
             System.out.println("From ITC, the max number of ports added are"+ports[0]);
             ips=true;
             break;                                                    
           }
        }
      System.out.println("After");

        if(ips==false)
         {
           /* that means it is a processor, which have no ports. */

             System.out.println("IPs is false");
             System.gc();
             select_port.add("0");/* all channels of a processors are bound to the same port of a processor*/
             ports[0]=0;
                                                         
         }  
          
      }
      catch (IOException ioe)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }
           System.out.println("Test point 3");
           fnode =  m_list.firstNode;
           System.out.println("Test point 4");
           while(fnode != null)
           {
              System.out.println("Test point 5");
              if(fnode.getMNode_data().equals(selected_task.trim()))
               {
	          System.out.println("Test point 6");
                   temp = fnode.data.channels;
                   System.out.println("The temp value "+temp);
                   for(j=1;j<=temp;j++)        
                     {
                        select_channel.add(""+j);
                        channels[0]=fnode.data.channels;
                     }
                        break;      
               }
               fnode = fnode.next_module;
           }
   Bind.addActionListener(this);
   Close.addActionListener(this);
   add(l0);       
   add(select_channel);
   add(l1);
   add(channels_chosen);
   add(l2);
   add(select_port);
   add(l3);
   add(ports_chosen);
   add(Bind);            
   add(Close);
     
   DelCIP_MyWindowAdapter adapter = new DelCIP_MyWindowAdapter(this);
   addWindowListener(adapter);

 }                       
   public void actionPerformed(ActionEvent ae)
   {
     String arg = ae.getActionCommand();
                     
       if(arg.equals("Bind"))
       {
          ports[i]= Integer.parseInt(select_channel.getSelectedItem().trim());
          channels[i++]= Integer.parseInt(select_port.getSelectedItem().trim());
          total1 = total1+select_channel.getSelectedItem().trim();
          total2 = total2+select_port.getSelectedItem().trim();
          channels_chosen.setText(total1);
          ports_chosen.setText(total2);
       }                      
       else if (arg.equals("Close"))
       {
          setVisible(false);
       }
   }
}
