import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class DM_full_form extends Frame implements ActionListener
 {
     private TextField f0,f1,f2,f3,f4;
     private int index,count;
     private Module_List m_list;
     private Module_Node temp;
     private Task_Node temp1;
     private task_class task_object;
     private Label l0,l1,l2,l3,l4,l5;
     private Button Delete, Cancel,Ditc;
     private StringTokenizer tokens;
     private Choice itc;

     public DM_full_form (int index , Module_List m_list)
     {
        super("Delete the module");
        this.index = index;
        this.m_list = m_list;
        Font f = new Font ("Serif", Font.BOLD+Font.PLAIN,15);
        setFont(f);
        setBackground(Color.lightGray);
        setLayout(new GridLayout(8,2,10,25));
        Delete = new Button("Delete entire task?");
        Cancel = new Button("Cancel");
        Ditc   = new Button ("Delete only  selected ITC"); 
        f0 = new TextField(5);
        f1 = new TextField(25);
        f2 = new TextField(10);
        f3 = new TextField(25);
        f4 = new TextField(5);
        l0 = new Label("Identifier");
        l5 = new Label("Number Of Channels");
        l1 = new Label("Repitition Rate ");
        l2 = new Label("Precedence");
        l3 = new Label("Source code file");
        l4 = new Label("The ITC ");
        itc = new Choice() ;
        itc.add("Channels   Task ID    Data      IN/OUT/INOUT");

        temp = m_list.firstNode;
        count = 0;
        while(count++ != index)
         temp = temp.next_module;
        f0.setText(temp.getMNode_data());
        f4.setText(""+temp.data.channels);
        f1.setText(""+temp.data.r_rate);
        f2.setText(""+temp.data.precedence);
        f3.setText(""+temp.data.code_pointer);
        temp1 = temp.next_task;
        while(temp1 != null)
           {
              itc.add(""+temp1.data.channels +"                    "+temp1.data.identifier
                   +"         "+temp1.data.amount_of_data+"              "+temp1.data.flag);
               
             temp1 = temp1.next_task;
           }
        f0.setEditable(false);
        f1.setEditable(false);
        f2.setEditable(false);
        f3.setEditable(false);
        f4.setEditable(false);
        Delete.addActionListener(this);
        Cancel.addActionListener(this);
        Ditc.addActionListener(this);
                 
        add(l0);
        add(f0);
        add(l5);
        add(f4);
        add(l1);
        add(f1);
        add(l2);
        add(f2);
        add(l3);
        add(f3);
        add(l4);
        add(itc);
        add(Delete);
        add(Cancel);
        add(Ditc);
                
        TITC_MyWindowAdapter adapter = new TITC_MyWindowAdapter(this);
        addWindowListener(adapter);
 }

    public void actionPerformed(ActionEvent e)
    {
        if(e.getSource() == Delete)
        {
           /* Delete the particular node from the list */
            m_list.remove(temp.getMNode_data());
            setVisible(false);
        }
            
         /* If cancel or otherwise, hide the window. */
                  
        else if(e.getSource() == Ditc)
        {            
            String arg = itc.getSelectedItem();

            tokens = new StringTokenizer(arg.trim());
            count = tokens.countTokens();
            task_object = new task_class();
            task_object.channels = Integer.parseInt(tokens.nextToken());
            task_object.identifier = tokens.nextToken().trim();
            task_object.amount_of_data = Double.valueOf(tokens.nextToken()).doubleValue();
            task_object.flag = Integer.parseInt(tokens.nextToken());
            m_list.removeITC(index,task_object);
            setVisible(false);
        }
       else
        setVisible(false);
    }
}



