import java.awt.event.*;
import java.awt.*;
import java.io.*;


public class MLoad_form extends Frame implements ItemListener
 {
        
        private Choice modules;
        private Label l0;
        Module_List  m_list;
        private RandomAccessFile module_file,module_total_size;
        private String identifier;
        private int count_of_tasks,count_itc,task_size,grand_total;
        private int file_position,counter,index;
        private task_class task_object;
        private module_class module_object;
        private Module_Node temp,temp2;
        private boolean duplicate;
        private char name[] = new char[15];
        private File m_file,mt_file;

      public MLoad_form(Module_List m_list)
      {
          super("Load an existing module");
          Font f = new Font("Serif",Font.BOLD+Font.PLAIN,15);
          setFont(f);
          setBackground(Color.lightGray);
          this.m_list = m_list;
          setLayout(new GridLayout(1,2,10,15));
          Choice modules = new Choice();
          Label l0 = new Label("Choose a task");
          add(l0);
          add(modules);
          modules.addItemListener(this);
          try
          {
            m_file = new File("module_file");
            mt_file = new File("module_total_size");
           if(m_file.exists() && mt_file.exists())
           {
            module_total_size = new RandomAccessFile("module_total_size","rw");
            module_file = new RandomAccessFile("module_file","r");
            grand_total = module_total_size.readInt(); /* No need of this in this file */
            count_of_tasks = module_total_size.readInt();
       
            task_size=0;
            for(int j=0;j<count_of_tasks;j++)
            {
              count_itc=module_file.readInt(); /* Read how many itc entries are there for this module */
              for(int i=0;i<15;i++)
                {     
                  name[i]=module_file.readChar();
                }
              identifier = new String(name);
              modules.add(identifier.trim());
              task_size += 80+count_itc*46; /* Each task is 76 bytes + 4 bytes itc_count,and itc is 46 bytes */
              module_file.seek((long)task_size);
            }
            module_file.close();
            module_total_size.close();
          }/* end of if*/
         }
          catch(IOException e)
          {
           System.out.println("The file is not opened properly");
          }
        TITC_MyWindowAdapter adapter = new TITC_MyWindowAdapter(this);
        addWindowListener(adapter);

    }                                          

  public void itemStateChanged(ItemEvent ie)     
   {
            
            Choice choice = (Choice)ie.getItemSelectable();
            index = choice.getSelectedIndex();
            file_position = 0;
            temp = m_list.firstNode;
          try
          {
           if(m_file.exists() && mt_file.exists())
           {
            module_file = new RandomAccessFile("module_file","r");
            counter = 0;
            while(counter != index)
            {
                  count_itc = module_file.readInt();
                  file_position += 80+count_itc*46;
                  module_file.seek(file_position);
                  counter++;
            }

            /* Now attach this selected module
             * to the beginning of the Module_List
             * After reading the task and its ITC entries from the file
             */

              module_object = new module_class();
              count_itc = module_file.readInt();
              for(int i=0;i<15;i++)
                {     
                  name[i]=module_file.readChar();
                }
              identifier = new String(name);
              module_object.identifier = identifier.trim();

           /* Check in the existing list if it is already added, 
            * that is to avoid dupliate module nodes being added.
            */
              duplicate = false;
              temp2=m_list.firstNode;
              while(temp2 != null)
              {
                if (temp2.data.identifier.equals(identifier.trim()))
                {
                 duplicate = true;
                 break;
                }
                else
                temp2 = temp2.next_module;
              }
            if(duplicate == false)
            {
              module_object.channels = module_file.readInt();
              module_object.r_rate = module_file.readDouble();
              module_object.precedence = module_file.readInt();
              for(int i=0;i<15;i++)
                {     
                  name[i]=module_file.readChar();
                }
              identifier = new String(name);
              module_object.code_pointer = identifier.trim();
              m_list.insertAtFront(module_object);

              /* Now attach its task list after reading it */

             
              for(int j=1;j<=count_itc;j++)
              {
                    task_object = new task_class();
                    task_object.channels = module_file.readInt();
                    for(int i=0;i<15;i++)
                         {     
                           name[i]=module_file.readChar();
                         }
                    identifier = new String(name);
                    task_object.identifier = identifier.trim();
                    task_object.amount_of_data = module_file.readDouble();
                    task_object.flag = module_file.readInt();
                    m_list.addnew_itc(0,task_object);
              }
           }
          module_file.close();
        } /* end of if */
      }
      catch(IOException e)
      {}
      setVisible(false);
  }
}


