import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class MemSpace_Util extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile memory_file,load_memories;
    private String memory_name_string;
    private memory_record m_record;
    private compute_space ftom;
    private Label  records;
    private int count,position;
    private File lm,mf;
    private Module_List m_list;
 
   public MemSpace_Util(Module_List m_list)
   {
     super ("Choose a memory...");
     m_record = new memory_record();
     this.m_list = m_list;
     components = new Choice();
     setLayout(new  FlowLayout());
     records = new Label("The Existing Memory Components are :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lm = new File("load_memories");
     mf = new File("memory_file");
   if(lm.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(mf.exists()&&(mf.length()!=0))
            {
               memory_file = new RandomAccessFile("memory_file","rw");
            }
            else
            {
              memory_file = new RandomAccessFile("memory_file","rw");
              count=0;
              position = -1;
            }
            load_memories = new RandomAccessFile("load_memories","rw");
            count = load_memories.readInt();   
            position = load_memories.readInt();
        }                                                                        
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
              setVisible(false);
        }
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             memory_file.seek( (long) k*(memory_class.object_size));
             m_record.read(memory_file); 
             memory_name_string  = m_record.getIdentifier();
             if(memory_name_string.startsWith("Deleted"))
             continue;
             components.add(memory_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
   components.addItemListener(this);
   add(records);
   add(components);
   DelCM_MyWindowAdapter adapter = new DelCM_MyWindowAdapter(this);
   addWindowListener(adapter);
  }

 public void itemStateChanged(ItemEvent e)
   {
      String to_be_deleted  = components.getSelectedItem();
      ftom = new compute_space(m_list,to_be_deleted.trim());
   }            
}
