import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;

public class ModCIP_form extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile ip_file,load_ips;
    private String ip_name_string;
    private ip_record ip_record;
    private file_to_ip_form ftoip;
    private Label  records;
    private File lip,ipf;
    private int count,position;
 
   public ModCIP_form(String title)
   {
     super ("Available " + title +  " Components for modification");
     ip_record = new ip_record();
     components = new Choice();
     setLayout(new  FlowLayout());
     records = new Label("The Existing IP/IO Components are :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lip = new File("load_ips");
     ipf = new File("ip_file");
   if(lip.exists())  /* If this does not exist, we can't load anything */
   {
     try
        {
            if(ipf.exists()&&(ipf.length()!=0))
            {
               ip_file = new RandomAccessFile("ip_file","rw");
            }
            else
            {
              ip_file = new RandomAccessFile("ip_file","rw");
              count=0;
              position = -1;
            }
            load_ips = new RandomAccessFile("load_ips","rw");
            count = load_ips.readInt();   
            position = load_ips.readInt();
        }
                   
     catch(IOException e)
        {
              System.err.println("From Del_C, File could not be opened ");
              setVisible(false);
        }
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Deleted"))
             continue;
             components.add(ip_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */

    /* if(ip_class.count_ip_forms >= 0)
     {
        try
         {
           ip_file = new RandomAccessFile("ip_file","rw");
         }
        catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened ");
              System.exit(1);
         }
        for(int k=0;k<=ip_class.count_ip_forms;k++)
        {
          try
          {
             ip_file.seek( (long) k*(ip_class.object_size));
             ip_record.read(ip_file); 
             ip_name_string  = ip_record.getIdentifier();
             if(ip_name_string.startsWith("Delet"))
             continue;
             components.add(ip_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       } */
     
   components.addItemListener(this);
   add(records);
   add(components);
   ModCIP_MyWindowAdapter adapter = new ModCIP_MyWindowAdapter(this);
   addWindowListener(adapter);
  }

 public void itemStateChanged(ItemEvent e)
   {
      String to_be_modified  = (components.getSelectedItem()).trim();
      ftoip = new file_to_ip_form ("Modify  IP Item",to_be_modified,ip_file,count,position);
      ftoip.setVisible(true);
      ftoip.setSize(600,300);
      setVisible(false);
   }
}
