import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class bus_to_file implements ActionListener
 {
      bus_to_file_form b_form;
      bus_class bus_object;
      private RandomAccessFile bus_file,load_buses;
      private bus_record b_record;
      private File bfile,lb;
      private int count,position;

    public bus_to_file(bus_to_file_form  b_form)
      {
          this.b_form=b_form;
          bus_object = new bus_class();
          b_form.repaint();
          b_record = new bus_record();
          lb = new File("load_buses");
          bfile = new File("bus_file");
      }

    public void actionPerformed (ActionEvent ae)
    {
  
       String arg  = (String) ae.getActionCommand();
       if (ae.getSource() == b_form.Clear)
       {
 //       b_form.f0.setText("");
        b_form.f1.setText("");
        b_form.repaint();
       }
       else if (ae.getSource() == b_form.Submit)
       {
         b_record.setIdentifier(b_form.busses.getSelectedItem().trim());
         b_record.setBwidth(Double.valueOf(b_form.f1.getText()).doubleValue());
                
         try          
           {
             if(lb.exists()&&(lb.length()> 4))
             {
               System.out.println("Load_Buses exists");
               load_buses = new RandomAccessFile("load_buses", "rw");
               count = load_buses.readInt();
               position = load_buses.readInt(); /* This is the position in the file, where to add this record. */             
               System.out.println("The read position is" + position);
             }
             else
              {
               System.out.println("Load_Buses does not exist");
               load_buses= new RandomAccessFile("load_buses", "rw");
               load_buses.writeInt(0); /* Set count to 0 */
               position = -1; /* next position to write in the memory_file will be 0 */
              }
              if(bfile.exists())
              {
                bus_file = new RandomAccessFile("bus_file", "rw");
              }
              else
              {
               System.out.println("Sorry, the library doesn't exist, \nCould not load memories");
               position = -1;
               bus_file = new RandomAccessFile("bus_file", "rw");
              }
          }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
               System.exit(1);
           }
          try
          {
            position++;
            bus_file.seek((long) (position*bus_class.object_size));
            b_record.write(bus_file);
            load_buses.seek((long) 4);    /* Re-store the incremented next position to write */
            System.out.println("The value of position "+position +"is re-stored");
            load_buses.writeInt(position);
          }
          catch (IOException e)
          {
              System.err.println("2:File not opened properly\n");
              System.exit(1);
          }
          try             
          {
              bus_file.close();
              load_buses.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
         b_form.setVisible(false);
     }
  }
}
