import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class file_to_processor_form extends Frame implements ActionListener 
{
     Label l0,l1,l2,l3,l4,l5,l6,l7,l8,l9,l10,l11,l12,l13,l14;
     TextField f0,f1,f2,f3,f4,f5,f6,f7,f8,f9,f10,f11,f12,f13,f14;
     private RandomAccessFile processor_file;
     Button Delete,Modify,Cancel;
     private String  to_be_deleted;
     private boolean  delete;
     private int  k;
     private processor_record p_record;

public file_to_processor_form(String title,String to_be_deleted,RandomAccessFile  processor_file,int count,int position) 
   {
      super(title);
      if(title.startsWith("Delet"))
      {
        delete = true;
      }
      else
        delete = false;
      p_record = new processor_record();
      this.to_be_deleted= to_be_deleted;
      this.processor_file = processor_file;
      setLayout(new GridLayout(17,2,10,15));
      setBackground(Color.lightGray);
      setForeground(Color.black);
      Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
      setFont(f);
      
      l0 = new Label("Processor");
      l1 = new Label("Speed");
      l9 = new Label("Memory Connection");
   //   l2 = new Label("Memory References per Intsruction:");
      l10 = new Label("Mem ref width in bytes");
      l3 = new Label("Primary Cache");
      l4 = new Label("Primary Cache Size ");
      l5 = new Label("Primary Cache Hit Ratio: ");
      l11 = new Label("Primary Cache Access Time");
      l6 = new Label("T_line read in ns");
      l7 = new Label("Write Policy ");
      l8 = new Label("T_line size in Bytes ");
      l12 = new Label("T_word write in ns:");
      l13 = new Label("T_line write in ns:");
      l14 = new Label("Dirty page ratio:");
            
      try
      { 
       for( k=count;k<=position;k++)
        {
          processor_file.seek((long) k*(processor_class.object_size));
          p_record.read(processor_file);
          if(to_be_deleted.equals(p_record.getIdentifier().trim()))
           {
             f0 = new TextField(p_record.getIdentifier().trim());
             f1 = new TextField(String.valueOf(p_record.getSpeed()));
             f9 = new TextField(p_record.getMemory().trim());
         //    f2 = new TextField(String.valueOf(p_record.getMref()));
             f10 = new TextField(String.valueOf(p_record.getMref_Width()));
             f3 = new TextField(String.valueOf(p_record.getP_identifier()));
             f4 = new TextField(String.valueOf(p_record.getP_size()));
             f5 = new TextField(String.valueOf(p_record.getP_hit_ratio()));
             f11 = new TextField(String.valueOf(p_record.getP_access_time()));
             f6 = new TextField(String.valueOf(p_record.getTlread()));
             f7 = new TextField(String.valueOf(p_record.getPolicy()));
             f8 = new TextField(String.valueOf(p_record.getTlsize()));
             f12 = new TextField(String.valueOf(p_record.getTw_write()));
             f13 = new TextField(String.valueOf(p_record.getTlwrite()));
             f14 = new TextField(String.valueOf(p_record.getDpratio()));

             break;
           }
        }
      }
      catch (IOException e)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }
       if(delete == true)
        {
          f0.setEditable(false);
          f1.setEditable(false);
          f9.setEditable(false);
       //   f2.setEditable(false);
          f3.setEditable(false);
          f4.setEditable(false);
          f5.setEditable(false);
          f11.setEditable(false);
          f6.setEditable(false);
          f7.setEditable(false);
          f8.setEditable(false);
          f10.setEditable(false);
          f12.setEditable(false);
          f13.setEditable(false);
          f14.setEditable(false);

        }
      Delete = new Button("Delete?");
      Modify = new Button("Modify?");
      Cancel = new Button("Cancel");
      add(l0); 
      add(f0);
      add(l1); 
      add(f1);
      add(l9);
      add(f9);
     // add(l2); 
     // add(f2);
      add(l10);
      add(f10);
      add(l3); 
      add(f3);
      add(l4); 
      add(f4);
      add(l5); 
      add(f5);
      add(l11); 
      add(f11);
      add(l6); 
      add(f6);
      add(l7); 
      add(f7);
      add(l8); 
      add(f8);
      add(l12); 
      add(f12);
      add(l13); 
      add(f13);
      add(l14); 
      add(f14);

      if(delete==true)
      {
        add(Delete);
        Delete.addActionListener(this);
      }
      else
      { 
        add(Modify);
        Modify.addActionListener(this);
      }
      add(Cancel);

      // register it to receive those events 

      Cancel.addActionListener(this);
    
      FP_MyWindowAdapter adapter = new FP_MyWindowAdapter(this);
      addWindowListener(adapter);
  }  
  public void actionPerformed(ActionEvent ae)
  {
     if (ae.getSource() == Delete)
       {
         try
         {
              p_record.setIdentifier(new String("Deleted"));
              processor_file.seek((long) (k)*(processor_class.object_size));
              p_record.write(processor_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
              processor_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
     else if (ae.getSource() == Modify)
       {
         try
         {
              p_record.setIdentifier(f0.getText().trim());
              p_record.setSpeed(Double.valueOf(f1.getText()).doubleValue());
              p_record.setMemory(f9.getText().trim());
          //    p_record.setMref(Double.valueOf(f2.getText()).doubleValue());
              p_record.setMref_Width(Double.valueOf(f10.getText()).doubleValue());
              p_record.setP_identifier(f3.getText());
              p_record.setP_size(Double.valueOf(f4.getText()).doubleValue());
              p_record.setP_hit_ratio(Double.valueOf(f5.getText()).doubleValue());
              p_record.setP_access_time(Double.valueOf(f11.getText()).doubleValue());
              p_record.setPolicy(f7.getText().trim());
              p_record.setTlread(Double.valueOf(f6.getText()).doubleValue());
              p_record.setTlsize(Double.valueOf(f8.getText()).doubleValue());
              p_record.setTw_write(Double.valueOf(f12.getText()).doubleValue());
              p_record.setTlwrite(Double.valueOf(f13.getText()).doubleValue());
              p_record.setDpratio(Double.valueOf(f14.getText()).doubleValue());
              processor_file.seek((long) (k)*(processor_class.object_size));
              p_record.write(processor_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
              processor_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
        else if(ae.getSource() == Cancel)
          {
              setVisible(false);
          }
 }
}  
