import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class memory_to_file implements ActionListener
 {
      memory_to_file_form m_form;
      memory_class memory_object;
      private RandomAccessFile memory_file;
      private RandomAccessFile lm;
      private memory_record m_record;
      private int position,count;
      private LM_record lm_record;
      private File load_memories,mfile;
      
      public memory_to_file(memory_to_file_form  m_form)
      {
          this.m_form=m_form;
          memory_object = new memory_class();
          m_form.repaint();
          m_record = new memory_record();
          lm_record = new LM_record();
          load_memories = new File("load_memories");
          mfile = new File("memory_file");
      }

    public void actionPerformed (ActionEvent ae)
    {
  
       String arg  = (String) ae.getActionCommand();
       
        if (ae.getSource() == m_form.Clear)
       {
        m_form.f0.setText("");
        m_form.f1.setText("");
        m_form.f2.setText("");
        m_form.f3.setText("");
        m_form.f4.setText("");
        m_form.f5.setText("");
        
       }
       else if (ae.getSource() == m_form.Submit)
        {
          memory_object.identifier = m_form.f0.getText().trim();
          m_record.setIdentifier(memory_object.identifier);
          memory_object.size = Double.valueOf(m_form.f1.getText().trim()).doubleValue();
          m_record.setSize(memory_object.size);
          memory_object.bw = Double.valueOf(m_form.f5.getText().trim()).doubleValue();
          m_record.setBw(memory_object.bw);
          memory_object.cycle_time = Double.valueOf(m_form.f2.getText().trim()).doubleValue();
          m_record.setCycle_time(memory_object.cycle_time);
          memory_object.access_time = Double.valueOf(m_form.f3.getText().trim()).doubleValue();
          m_record.setAccess_time(memory_object.access_time);
          memory_object.interleaving = Integer.parseInt(m_form.f4.getText().trim());
          m_record.setInterleaving(memory_object.interleaving);
       
          try
           {
             if(load_memories.exists()&&(load_memories.length()> 4))
              {
               lm = new RandomAccessFile("load_memories", "rw");
               count = lm.readInt();
               position=lm.readInt(); /* This is the position in the file, where to add this record. */             
              }
             else
              {
               lm = new RandomAccessFile("load_memories", "rw");
               lm.writeInt(0); /* Set count to 0 */
               position = -1; /* next position to write in the memory_file will be 0 */
              }
              if(mfile.exists())
              {
                memory_file = new RandomAccessFile("memory_file", "rw");
              }
              else
              {
               position = -1;
               memory_file = new RandomAccessFile("memory_file", "rw");
              }
           }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
               System.exit(1);
           }
          try
          {
            position++;
            memory_file.seek((long) (position*memory_class.object_size));
            m_record.write(memory_file);
            lm.seek((long) 4);    /* Re-store the incremented next position to write */
            lm.writeInt(position);
          }
          catch (IOException e)
          {
              System.err.println("2:File not opened properly\n");
              System.exit(1);
          }
          try
          {
              memory_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
         m_form.setVisible(false);
     }
  }
}
