import java.awt.*;
import java.awt.event.*;

public class processor_tm_primary_cache extends Frame  implements ActionListener,ItemListener
   {
      private Label l0,l1,l2,l3,l4,l5,l6,l7,l8;
      private TextField f0,f1,f2,f3,f4,f5,f6,f7,f8;
      private Button Clear,Done;
      private Choice policy;
      private PT_MyTextHandler pmt;

 /* Constructor for TM processor primary cache */

     public processor_tm_primary_cache(PT_MyTextHandler pmt)
     {
       super("The Primary Cache Characteristics of TM");
       this.pmt = pmt;
       setLayout(new GridLayout(11,2,10,15));
       Font f = new Font("Serif", Font.BOLD+Font.PLAIN, 15);
       setFont(f);
       l0 = new Label(" Size of Primary Cache in KB");
       l1 = new Label(" Default Hit ratio :");
       l2 = new Label(" Access time in ns :");
       l3 = new Label("T_line read in ns");
       l4= new Label("Policy");
       l5 = new Label("Line size in Bytes is");
       l6 = new Label("T_word write in ns");
       l7 = new Label("T_line write in ns");
       l8 = new Label("Dirty page probablity");
       policy = new Choice();
       policy.add("WTNWA");
       policy.add("CBWA");
      
       f0 = new TextField(5);
       f1 = new TextField(5);
       f2 = new TextField(5);
       f3 = new TextField(5);
       f5 = new TextField(5);
       f6 = new TextField(5);
       f7 = new TextField(5);
       f8 = new TextField(5);
       Clear = new Button("Clear");
       Done  = new Button("Submit");

       add(l0);
       add(f0);
       add(l1);
       add(f1);
       add(l2);
       add(f2);
       add(l3);
       add(f3);
       add(l4);
       add(policy);
       add(l5);
       add(f5);
       add(l6);
       add(f6);
       add(l7);
       add(f7);
       add(l8);
       add(f8);
       add(Clear);
       add(Done);
       Clear.addActionListener(this);
       Done.addActionListener(this);
       policy.addItemListener(this);
       CG_MyWindowAdapter adapter = new CG_MyWindowAdapter(this);
       addWindowListener(adapter);
     }

     public void actionPerformed(ActionEvent ae)
     {
        if(ae.getSource() == Clear)
        {
          f0.setText("");
          f1.setText("");
          f2.setText("");
          f3.setText("");
          f5.setText("");
          f6.setText("");
          f7.setText("");
          f8.setText("");
        }
        else if (ae.getSource() == Done)
       {
          pmt.p_record.setP_identifier("Exists");
          pmt.p_record.setP_size(Double.valueOf(f0.getText().trim()).doubleValue());
          pmt.p_record.setP_hit_ratio(Double.valueOf(f1.getText().trim()).doubleValue());
          pmt.p_record.setP_access_time(Double.valueOf(f2.getText().trim()).doubleValue());
          pmt.p_record.setTlread(Double.valueOf(f3.getText().trim()).doubleValue());
          pmt.p_record.setTlsize(Double.valueOf(f5.getText().trim()).doubleValue());
          pmt.p_record.setTw_write(Double.valueOf(f6.getText().trim()).doubleValue());
          pmt.p_record.setTlwrite(Double.valueOf(f7.getText().trim()).doubleValue());
          pmt.p_record.setDpratio(Double.valueOf(f8.getText().trim()).doubleValue());
          setVisible(false);
       
       }
    }
 public void itemStateChanged(ItemEvent ie)
    
   {

         if (ie.getSource()==policy)

           {
                 pmt.p_record.setPolicy(policy.getSelectedItem().trim());
                   
          }           
   }
}
