import java.awt.*;
import java.awt.event.*;

public class processor_tm_secondary_cache extends Frame  implements ActionListener
   {
      private Label l0,l1,l2;
      private TextField f0,f1,f2;
      private Button Clear,Done;
      private PT_MyTextHandler pmt;

 /* Constructor for TM processor secondary cache */

     public processor_tm_secondary_cache(PT_MyTextHandler pmt)
     {
       super("The Secondary Cache Characteristics of TM");
       this.pmt = pmt;
       setLayout(new GridLayout(4,2,10,15));
       Font f = new Font("Serif", Font.BOLD+Font.PLAIN, 15);
       setFont(f);
       l0 = new Label(" Size of Secondary Cache in KB");
       l1 = new Label(" Default Hit ratio :");
       l2 = new Label("Access Time in ns");
       f0 = new TextField(5);
       f1 = new TextField(5);
       f2 = new TextField(5);
       Clear = new Button("Clear");
       Done  = new Button("Submit");

       add(l0);
       add(f0);
       add(l1);
       add(f1);
       add(l2);
       add(f2);
       add(Clear);
       add(Done);
       Clear.addActionListener(this);
       Done.addActionListener(this);

       CG_MyWindowAdapter adapter = new CG_MyWindowAdapter(this);
       addWindowListener(adapter);
     }

     public void actionPerformed(ActionEvent ae)
     {
        if(ae.getSource() == Clear)
        {
          f0.setText("");
          f1.setText("");
          f2.setText("");
        }
        else if (ae.getSource() == Done)
       {
          pmt.p_record.setS_identifier("Exists");
          pmt.p_record.setS_size(Double.valueOf(f0.getText().trim()).doubleValue());
          pmt.p_record.setS_hit_ratio(Double.valueOf(f1.getText().trim()).doubleValue());
          pmt.p_record.setS_access_time(Double.valueOf(f2.getText().trim()).doubleValue());
          setVisible(false);
       
       }
    }
}
