import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class BW_Util extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile bus_file,load_buses;
    private String bus_name_string;
    private bus_record b_record;
    private compute_bu  bw;
    private Label  records;
    private File bf,lb;
    private int count,position,i,index;
    private Module_List m_list;
    private Ctob_binding_List ctob_list;
    private double[] bws;
    
 
   public BW_Util(Module_List m_list,Ctob_binding_List ctob_list)
   {
     super ("Choose a bus to view to its utilization");
     this.m_list=m_list;
     this.ctob_list = ctob_list;
     b_record = new bus_record();
     components = new Choice();
     bws = new double[5];
     setLayout(new  FlowLayout());
     records = new Label("Choose a bus :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lb = new File("load_buses");
     bf = new File("bus_file");
   if(lb.exists())  /* If this does not exist, we can't load anything */
   {
     System.out.println("Lb exists");
     try
      {
            if(bf.exists()&&(bf.length()!=0))
            {
               bus_file = new RandomAccessFile("bus_file","rw");
            }
            else
            {
              bus_file = new RandomAccessFile("bus_file","rw");
              System.out.println("not exists and bf is opened");
              count=0;
              position = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From BW_Util, File could not be opened. ");
              setVisible(false);
         }
     try
      {
            load_buses = new RandomAccessFile("load_buses","rw");
            count = load_buses.readInt();   
            position = load_buses.readInt();
      }
                   
     catch(IOException e)
         {
              System.err.println("load_buses File could not be opened. ");
              setVisible(false);
         }
     i=0;         
     for(int k=count;k<=position;k++)
        {
          try
          {
             bus_file.seek( (long) k*(bus_class.object_size));
             b_record.read(bus_file); 
             bus_name_string  = b_record.getIdentifier();
             if(bus_name_string.startsWith("Deleted"))
             continue;
             components.add(bus_name_string.trim());
             bws[i++]=b_record.getBwidth();
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
                   
   components.addItemListener(this);
   add(records);
   add(components);
   DelCB_MyWindowAdapter adapter = new DelCB_MyWindowAdapter(this);
   addWindowListener(adapter);
}

 public void itemStateChanged(ItemEvent e)
   {
      String to_be_computed  = components.getSelectedItem().trim();
      index = components.getSelectedIndex();
      bw = new compute_bu (m_list,ctob_list,to_be_computed,bws[index]);
      setVisible(false);
   }
}
