import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class DelCB_form extends Frame implements ItemListener
 { 
    private Choice components;
    private RandomAccessFile bus_file,load_buses;
    private String bus_name_string;
    private bus_record b_record;
    private file_to_bus_form ftob;
    private Label  records;
    private File bf,lb;
    private int count,position;
 
   public DelCB_form(String title)
   {
     super ("Available " + title +  " Components for deletion");
     b_record = new bus_record();
     components = new Choice();
     setLayout(new  FlowLayout());
     records = new Label("The Existing Bus Components are :");
     setBackground(Color.lightGray);
     setForeground(Color.black);
     Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
     setFont(f);
     lb = new File("load_buses");
     bf = new File("bus_file");
   if(lb.exists())  /* If this does not exist, we can't load anything */
   {
     try
      {
            if(bf.exists()&&(bf.length()!=0))
            {
               bus_file = new RandomAccessFile("bus_file","rw");
            }
            else
            {
              bus_file = new RandomAccessFile("bus_file","rw");
              count=0;
              position = -1;
            }
       }
     catch(IOException e)
         {
              System.err.println("From Del_C, File could not be opened. ");
              setVisible(false);
         }
     try
      {
            load_buses = new RandomAccessFile("load_buses","rw");
            count = load_buses.readInt();   
            position = load_buses.readInt();
          //  load_buses.close();
      }
                   
     catch(IOException e)
         {
              System.err.println("load_buses File could not be opened. ");
              setVisible(false);
         }
              
     for(int k=count;k<=position;k++)
        {
          try
          {
             bus_file.seek( (long) k*(bus_class.object_size));
             b_record.read(bus_file); 
             bus_name_string  = b_record.getIdentifier();
             if(bus_name_string.startsWith("Deleted"))
             continue;
             components.add(bus_name_string.trim());
          }
          catch(IOException e)
          {
              System.err.println("File could not be read ");
              System.exit(1);
          }
       }   
    }/* end of if */
                   
   components.addItemListener(this);
   add(records);
   add(components);
   DelCB_MyWindowAdapter adapter = new DelCB_MyWindowAdapter(this);
   addWindowListener(adapter);
}

 public void itemStateChanged(ItemEvent e)
   {
      String to_be_deleted  = components.getSelectedItem();
      ftob = new file_to_bus_form ("Delete Bus Item",to_be_deleted,bus_file,count,position);
      ftob.setVisible(true);
      ftob.setSize(600,300);
      setVisible(false);
   }
}
