/* This file, when loading  the bus components, sets the count on the existing bus components
 * to zero, indicating that all the busses are loaded from the library. The count indicates the lower bound
 * after which from  the file "bus_file", busess are to be considered. Similar is the case with L*_Components 
 * files.
 */

import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class LB_Components 
 {
      private RandomAccessFile lb;
      private LB_record lb_record;
       
      public LB_Components()
      {
             lb_record = new LB_record();
             try             
             {
               lb = new RandomAccessFile("load_buses", "rw");
               lb_record.Setcount(0);
               lb_record.write(lb);
             }
             catch (IOException e)
             {
               System.err.println("File not opened properly\n ");
               System.exit(1);
             }
                                                  
       /*     Decrement Lowerbound (count) so that it point to 0 and
        *     exisiting components are read.
        */
            
          try          
          {
              lb.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
     }
 }
