import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class Set_Parameters 
 {
      private RandomAccessFile lm;
      private LM_record lm_record;
      private memory_class memory_object;
      private int count;
      
      public Set_Parameters()
      {
           lm_record = new LM_record();
           memory_object = new memory_class();
           try            
           {
              lm = new RandomAccessFile("load_memories", "r");
              lm.seek((long)0);
              lm_record.read(lm);
           }
          catch (IOException e)
           {
               System.err.println("File not opened properly\n ");
               System.exit(1);
           }
           count = lm_record.getcount();
           memory_object.lowerbound = count;

           /* Increment Lowerbound so that already existing components
            * are not not Loaded
            */

          try            
          {
              lm.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
     }
 }
