import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class MenuF_MyWindowAdapter extends WindowAdapter 
{
   MenuFrame  m_form;
   private RandomAccessFile lm,lp,lb,lip;
   private int position;
   private File lipf ;
                                                 
   public MenuF_MyWindowAdapter(MenuFrame m_form)
   {
     this.m_form = m_form;
   }

   public void windowClosing (WindowEvent we)
  {
   /* Set the count in load_**** files to position before exiting ,
    * by calling the following function so that
    * unwantedly memories,processors etc., are not loaded beforehand.
    */

  // For Memory Components.
         try            
           {
              lm = new RandomAccessFile("load_memories", "rw");
              lm.seek((long)4);
              position = lm.readInt();
              lm.seek((long)0);
              lm.writeInt(position+1); /*Set count to position*/
              lm.close();
              m_form.setVisible(false);
           }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
              // System.exit(1);
           }

    // For Processor Components.

         try            
           {
              lp = new RandomAccessFile("load_processors", "rw");
              lp.seek((long)4);
              position = lp.readInt();
              lp.seek((long)0);                                       
              lp.writeInt(position+1); /*Set count to position*/
              lp.close();                        
              m_form.setVisible(false);
              System.gc();
           }
          catch (IOException e)
           {
               System.err.println("2.File not opened properly\n ");
            //   System.exit(1);
           }

  // For Bus Components.
         try            
           {
              lb = new RandomAccessFile("load_buses", "rw");
              lb.seek((long)4);
              position = lb.readInt();
              lb.seek((long)0);                                            
              lb.writeInt(position+1); /*Set count to position*/
              lb.close();                                          
              m_form.setVisible(false);
           }
          catch (IOException e)
           {
               System.err.println("3.File not opened properly\n ");
             //  System.exit(1);
           }
// For IP Components

                     
         try            
           {
              lip = new RandomAccessFile("load_ips", "rw");
              lip.seek((long)4);
              position = lip.readInt();                         
              System.out.println("The position read "+ position );
              lip.seek((long)0);
              lip.writeInt(position+1); /*Set count to position*/
              lip.close();
              m_form.setVisible(false);
           }
          catch (IOException e)
           {
               System.err.println("4.File not opened properly\n ");
               System.exit(1);
           }
   }
}
   
