import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class PT_MyTextHandler implements ActionListener,ItemListener
 {
      processor_tmform  ptm_form;
      processor_tm_primary_cache pcache;
  //    processor_tm_secondary_cache scache;
      processor_record p_record;
      processor_class processor_object;
      RandomAccessFile processor_file,load_processors;
      private int count,position;
      private File lp,pfile;

      public PT_MyTextHandler(processor_tmform  ptm_form)
      {
          this.ptm_form=ptm_form;
          p_record = new processor_record();

          /* By default there are no Caches */

          p_record.setP_identifier("None");
          p_record.setPolicy("None");
          lp = new File("load_processors");
          pfile = new File("processor_file");

      }
    public void actionPerformed (ActionEvent ae)
    {
  
       String arg  = (String) ae.getActionCommand();
       
       if (ae.getSource() == ptm_form.Clear)
       {
        ptm_form.f0.setText("");
        ptm_form.f1.setText("");
        ptm_form.f2.setText("");
        ptm_form.f3.setText("");
        ptm_form.f4.setText("");
       }
       else if (ae.getSource() == ptm_form.Done)
       {
          p_record.setIdentifier(ptm_form.f0.getText().trim());
          p_record.setSpeed(Double.valueOf(ptm_form.f1.getText()).doubleValue());
          p_record.setMemory(ptm_form.f3.getText().trim());
//          p_record.setMref(Double.valueOf(ptm_form.f2.getText()).doubleValue());
          p_record.setMref_Width(Double.valueOf(ptm_form.f4.getText()).doubleValue());
          processor_object =   new processor_class();
         try         
           {
             if(lp.exists()&&(lp.length()> 4))
              {
               System.out.println("Load_Processors exists");
               load_processors = new RandomAccessFile("load_processors", "rw");
               count = load_processors.readInt();
               position=load_processors.readInt(); /* This is the position in the file, where to add this record. */             
               System.out.println("The read position is" + position);
              }
             else
              {
               System.out.println("Load_processors does not exist");
               load_processors= new RandomAccessFile("load_processors", "rw");
               load_processors.writeInt(0); /* Set count to 0 */
               position = -1; /* next position to write in the memory_file will be 0 */
              }
              if(pfile.exists())
              {
                processor_file = new RandomAccessFile("processor_file", "rw");
              }
              else
              {
               System.out.println("Sorry, the library doesn't exist, \nCould not load memories");
               position = -1;
               processor_file = new RandomAccessFile("processor_file", "rw");
              }
          }
          catch (IOException e)
           {
               System.err.println("1.File not opened properly\n ");
               System.exit(1);
           }
          try
          {
            position++;
            processor_file.seek((long) (position*processor_class.object_size));
            p_record.write(processor_file);
            load_processors.seek((long) 4);    /* Re-store the incremented next position to write */
            System.out.println("The value of position "+position +"is re-stored");
            load_processors.writeInt(position);
          }
          catch (IOException e)
          {
              System.err.println("2:File not opened properly\n");
              System.exit(1);
          }

         try     
          {
           processor_file.close();
           load_processors.close();
          }
          catch(IOException e)
          {
            System.out.println("Processor file could not be closed");
            System.exit(1);
          }
      
         ptm_form.setVisible(false);
       }
  }
  
  public void itemStateChanged(ItemEvent e)
   {
     if(ptm_form.Cache.getSelectedItem()=="Primary Cache")
     {
       pcache = new processor_tm_primary_cache(this);
       pcache.setVisible(true);
       pcache.setSize(600,600);
     }
/*     else if (ptm_form.Cache.getSelectedItem()=="Secondary Cache")
     {
       scache = new processor_tm_secondary_cache(this);
       scache.setVisible(true);
       scache.setSize(600,300);
     }*/
   }
}
