import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class SM_to_file extends Frame
{
    private int index,file_position;
    private Module_List m_list;
    private Module_Node temp;
    private Task_Node temp1;
    private RandomAccessFile module_file,module_total_size;
    private StringBuffer buf;
    private String pointer,identifier;
    private int counter,count_of_tasks,count_of_itc,grand_itc_count,prev_count_of_tasks;
    private File mtsize,mfile;           

    public SM_to_file(int index, Module_List m_list)
    {
       this.index = index;
       this.m_list = m_list;
                
       temp = m_list.firstNode;

       /* First get the count of number of tasks. */

       count_of_tasks = 0;
       grand_itc_count = 0;
       while(temp!=null)
       {
          count_of_tasks++;
          temp = temp.next_module;         
       }
       temp = m_list.firstNode;
       mtsize = new File("module_total_size");
       mfile  = new File("module_file");
       if(mtsize.exists())
          {
              try
               {
                  System.out.println("mtsize already exists");
                  module_total_size = new RandomAccessFile("module_total_size","rw");
                  file_position = module_total_size.readInt();
                  prev_count_of_tasks = module_total_size.readInt();
                  System.out.println("The file size is and prev count of tasks is "+ file_position+"and"+prev_count_of_tasks);
                  if(!(mfile.exists()))
                        {
                           System.out.println("Sorry, the module_file does not exist,\n Could not load the required modules");
                           file_position = 0;
                           module_file = new RandomAccessFile("module_file","rw");
                        }
                  else
                        {
                        try
                           {
                                 module_file = new RandomAccessFile("module_file","rw");
                                 module_file.seek((long)file_position);
                           }
                        catch(IOException e)
                           {}
                        }

                  }
              catch(IOException e)
              {}
          }
       else
          {
               try
                  {
                         System.out.println("mtsize does not exist ");
                         module_file = new RandomAccessFile("module_file","rw");
                         module_total_size = new RandomAccessFile("module_total_size","rw");
                         prev_count_of_tasks = 0;
                  }
                       catch(IOException e)
                         {}
           }
          


       if(index == 0)  /* That is, Save all */
       {
          try
              {
                       while(temp!=null)
                       {
                               count_of_itc = 0; /* ITC entry count of each module */
                               temp1=temp.next_task;
                               while(temp1 != null)
                                     {
                                       count_of_itc++;
                                       temp1=temp1.next_task;
                                     }
              
                               grand_itc_count += count_of_itc;
                               module_file.writeInt(count_of_itc);
                               identifier = temp.getMNode_data();
                               buf = new StringBuffer(identifier);
                               buf.setLength(15);
                               module_file.writeChars(buf.toString());
                               module_file.writeInt(temp.data.channels);
                               module_file.writeDouble(temp.data.r_rate);
                               module_file.writeInt(temp.data.precedence);
                               pointer = temp.data.code_pointer;
                               buf = new StringBuffer(pointer);
                               buf.setLength(15);
                               module_file.writeChars(buf.toString());

                               /*Now, write the ITC entries of this module */

                               temp1 = temp.next_task;
                               while(temp1 != null)
                                   {
                                        module_file.writeInt(temp1.data.channels);
                                        identifier = temp1.data.identifier;
                                        System.out.println("The task ITC "+identifier+"is written to file");
                                        buf = new StringBuffer(identifier);
                                        buf.setLength(15);
                                        module_file.writeChars(buf.toString());
                                        module_file.writeDouble(temp1.data.amount_of_data);
                                        module_file.writeInt(temp1.data.flag);
                                        temp1 = temp1.next_task;
                                   }

                         
                               temp = temp.next_module;
                       }/* end of while */
              }  /* end of try */
          catch(IOException e)
          {
              System.out.println("Error occurred");
          }
       }
       else  /* Save a particular module */
          {
                                  
                counter = 1;
                while(counter != index)
                     {
                          counter++;
                          temp = temp.next_module;
                     }
                          
                try  /* Now store that module */
                     {
                           count_of_itc = 0; /* ITC entry count of each module */
                           temp1=temp.next_task;
                           while(temp1 != null)
                            {
                             count_of_itc++;
                             temp1=temp1.next_task;
                            }
                           grand_itc_count += count_of_itc;
                           module_file.writeInt(count_of_itc);
                           identifier = temp.getMNode_data();
                           buf = new StringBuffer(identifier);
                           buf.setLength(15);
                           module_file.writeChars(buf.toString());
                           module_file.writeInt(temp.data.channels);
                           module_file.writeDouble(temp.data.r_rate);
                           module_file.writeInt(temp.data.precedence);
                           pointer = temp.data.code_pointer;
                           buf = new StringBuffer(pointer);
                           buf.setLength(15);
                           module_file.writeChars(buf.toString());
                           temp1 = temp.next_task;         
                           while(temp1 != null)
                            {
                              module_file.writeInt(temp1.data.channels);
                              identifier = temp1.data.identifier;
                              System.out.println("The task ITC "+identifier+"is written to file");
                              buf = new StringBuffer(identifier);
                              buf.setLength(15);
                              module_file.writeChars(buf.toString());
                              module_file.writeDouble(temp1.data.amount_of_data);
                              module_file.writeInt(temp1.data.flag);
                              temp1 = temp1.next_task;
                            }

                          }
                catch(IOException e)
                {}
                count_of_tasks=1;       /* As only one task is to be stored */
                System.out.println("The count of tasks is set to 1");
          }                           /* End of else
                                       */
               
       /* Re-Store the present total number of bytes in the file module_total_size */
       try
          {
                module_total_size.seek((long)0);
                module_total_size.writeInt(file_position+count_of_tasks*80+grand_itc_count*46);
                System.out.println("The current total size "+(file_position+count_of_tasks*72+grand_itc_count*46) +"is written to file");

                /* Grand ITC Total is the total number of tasks in ITC of all tasks and 
                 * Re-store Total count_of_tasks  in this file
                 */

                module_total_size.writeInt(prev_count_of_tasks+count_of_tasks);
                System.out.println("The count of tasks is "+(prev_count_of_tasks+count_of_tasks)+"is writen to file");
                module_file.close();
                module_total_size.close();
          }
          catch(IOException e)
          {}
        
        SM_MyWindowAdapter adapter = new SM_MyWindowAdapter(this);
        addWindowListener(adapter);
        
                          
    }

}






