import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class compute_MBw
 {
    
    private RandomAccessFile processor_file,ip_file;
    private RandomAccessFile load_processors,memory_file,load_memories,load_ips;
    private String processor_name_string,memory_name_string,memory,ip_name_string;
    private processor_record p_record;
    private ip_record ip_record;
    private memory_record m_record;
    private String[] final_names,processors,task_names,Policies;
    private double[] final_mrefs;
    private double e_access_time,g_total,total_bytes,mref_per_inst;
    private double[] Phit,Shit,Mref,r_rates,d_insts,s_insts,mref_widths,Tlinesizes,Dpratios;
    private File lp,pf,lm,mf,lip,ipf;
    private int position,count,i,p_len,x,m;
    private Module_List m_list;
    private Module_Node fnode;
    private TtoC_binding_Node bnode;
    private draw_pie dp;
    String  data;
					     
    public compute_MBw(Module_List m_list,String selected_memory,double bw)
	   {
	    
	     p_record = new processor_record();
	     m_record = new memory_record();
             ip_record = new ip_record();

	     processors = new String[10];
             task_names = new String[10];
             Policies = new String[10];
             final_names = new String[25];
             final_mrefs = new double[25];
             mref_widths = new double[10];
             Phit= new double[10];
          //   Shit = new double[10];
             r_rates = new double[10];
             d_insts = new double[10];
             s_insts = new double[10];
             Dpratios = new double[10];
             Tlinesizes = new double[10];

             this.m_list = m_list;
             System.gc();     /* Explicit call to Garbage Collector. */
	     lp = new File("load_processors");
	     pf = new File("processor_file");

	   if(lp.exists())  /* If this does not exist, we can't load anything */
	   {
	       
	     try
		   {
		    if(pf.exists()&&(pf.length()!=0))
		    {
		     
		       processor_file = new RandomAccessFile("processor_file","rw");
		    }
		    else
		    {
		      processor_file = new RandomAccessFile("processor_file","rw");
		      count=0;
		      position = -1;
		    }
		    load_processors = new RandomAccessFile("load_processors","rw");
		    count = load_processors.readInt();   
		    position = load_processors.readInt();
                   }                                                                
			   
	     catch(IOException e)
		 {
		      System.err.println("From Del_C, File could not be opened ");
                   
		 }
		i=0;
	     
		for(int k=count;k<=position;k++)
		{
		  try
		  {
		     processor_file.seek( (long) k*(processor_class.object_size));
		     p_record.read(processor_file); 
		     processor_name_string  = p_record.getIdentifier();
                     if(processor_name_string.startsWith("Delet"))               
		       continue;
		     memory = p_record.getMemory();
                    
                     if(memory.trim().equals(selected_memory))

		      {
                        processors[i] = processor_name_string;
                        mref_widths[i]= p_record.getMref_Width();
                        Policies[i]=p_record.getPolicy();
                        if(!(Policies[i].equals("null")))
                        {
                          Tlinesizes[i]=p_record.getTlsize();
                          Dpratios[i]= p_record.getDpratio();
                          Phit[i]=p_record.getP_hit_ratio();
                        } 
                        i++;
		      }

		  }
		  catch(IOException e)
		  {
		      System.err.println("File could not be read ");
		      System.exit(1);
		  }
	       }
	   }

           /* Check for the tasks bound to the processors in the array
	    * "processors".
	    */
	    p_len = i;
            x=0;          
            g_total = 0.0;
          for(int j=0;j<p_len;j++)
          {
             System.gc();
             i=0;
             data= processors[j];
      //       e_access_time = (1-Phit[j]/100.0)*(1-Shit[j]/100.0);
      //       System.out.println("The effe.access time is" + ","+Phit[j]+","+Shit[j]+","+e_access_time);
        //     mref_per_inst = Mref[j];
             fnode = m_list.firstNode;
             while(fnode != null)
             {
                  bnode = fnode.next_binding;
                  if(data.trim().equals(bnode.data.component.trim()))
		     {
                         d_insts[i]= bnode.data.d_inst+bnode.data.l_inst;
                         s_insts[i]= bnode.data.s_inst;
                         r_rates[i]=1000/fnode.data.r_rate; /* Repetition rate is in milli seconds */
                         task_names[i++]=bnode.data.task;
                 
                     }
                                    
                  fnode = fnode.next_module;    
             }       
           
          
          /* Now having got all the tasks that are mapped to a particular
           * Processor as well as their dynamic sizes and repitition rates,
           * Calculate the number of Mref per sec for each task.
           */
            
             for(m=0;m<i;m++)
             {
               if(Policies[j].startsWith("CB"))
               {
                total_bytes=(d_insts[m]+s_insts[m])*r_rates[m]*(1-Phit[j]/100)*Tlinesizes[j]*mref_widths[j]*(1+Dpratios[j]);
               }
               else if(Policies[j].startsWith("WT"))
               {
                 total_bytes=((d_insts[m]*(1-Phit[j]/100)*Tlinesizes[j]*mref_widths[j])+(s_insts[m]*mref_widths[j]))*r_rates[m];
               }
               else /* There is no cache */
               {
                 total_bytes=(d_insts[m]+s_insts[m])*r_rates[m]*mref_widths[j];
               }   

                  final_names[x]=task_names[m]+" Bytes/sec on "+processors[j];
                  final_mrefs[x++]=total_bytes;
             }
              
          } /* End of outermost for  */
          /* Finally include the Grand Total in the array */
          final_mrefs[x]=bw*1024*1024;/* MBytes to Bytes */
          System.out.println("The Gtotal " + final_mrefs[x]);
                                
   dp =new draw_pie("Bandwidth Utilization of"+" "+selected_memory,final_names,final_mrefs,x);
   dp.setSize(1000,530);
   dp.setVisible(true);
   
 }

}      


