import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.io.*;


public class file_to_bus_form extends Frame implements ActionListener 
{
     Label l0,l1;
     TextField f0,f1;
     private RandomAccessFile bus_file;
     Button Delete,Modify,Cancel;
     private String  to_be_deleted;
     private boolean  delete;
     private int  k;
     private bus_record b_record;

public file_to_bus_form(String title,String to_be_deleted,RandomAccessFile  bus_file,int count,int position) 
   {
      super(title);
      if(title.startsWith("Del"))
      {
        delete = true;
      }
      else
        delete = false;
      b_record = new bus_record();
      this.to_be_deleted= to_be_deleted;
      this.bus_file = bus_file;
      setLayout(new GridLayout(4,2,10,15));
      setBackground(Color.lightGray);
      setForeground(Color.black);
      Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
      setFont(f);
      
      l0 = new Label("Bus Identifier");
      l1 = new Label("Bus BandWidth in MBPS");
      try
      { 
       for( k =count; k<=position;k++)
        {
          bus_file.seek((long) k*(bus_class.object_size));
          b_record.read(bus_file);
          if(to_be_deleted.equals(b_record.getIdentifier().trim()))
           {
             f0 = new TextField(b_record.getIdentifier().trim());
             f1 = new TextField(String.valueOf(b_record.getBwidth()));
             break;                       
           }
        }
      }
      catch (IOException e)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }
       if(delete == true)
        {
          f0.setEditable(false);
          f1.setEditable(false);
        }           

      Delete = new Button("Delete?");
      Modify = new Button("Modify?");
      Cancel = new Button("Cancel");
      add(l0); 
      add(f0);
      add(l1); 
      add(f1);
      if(delete==true)
      {
        add(Delete);
        Delete.addActionListener(this);
      }
      else
      { 
        add(Modify);
        Modify.addActionListener(this);
      }
      add(Cancel);

      // register it to receive those events 

      Cancel.addActionListener(this);
    
      FB_MyWindowAdapter adapter = new FB_MyWindowAdapter(this);
      addWindowListener(adapter);
  }  
  public void actionPerformed(ActionEvent ae)
  {
     if (ae.getSource() == Delete)
       {
         try
         {
              b_record.setIdentifier(new String("Deleted"));
              bus_file.seek((long) (k)*(bus_class.object_size));
              b_record.write(bus_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
             bus_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
     else if (ae.getSource() == Modify)
       {
         try
         {
              b_record.setIdentifier(f0.getText().trim());
              b_record.setBwidth(Double.valueOf(f1.getText()).doubleValue());
              bus_file.seek((long) (k)*(bus_class.object_size));
              b_record.write(bus_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
            bus_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
        else if(ae.getSource() == Cancel)
          {
              setVisible(false);
          }
 }
public void paint(Graphics g)
{
 
}
}
