import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.io.*;


public class file_to_ip_form extends Frame implements ActionListener 
{
     Label l0,l1;
     TextField f0,f1;
     private RandomAccessFile ip_file;
     Button Delete,Modify,Cancel;
     private String  to_be_deleted;
     private boolean  delete;
     private int  k;
     private ip_record ip_record;

public file_to_ip_form(String title,String to_be_deleted,RandomAccessFile  ip_file,int count,int position) 
   {
      super(title);
      if(title.startsWith("Del"))
      {
        delete = true;
      }
      else
        delete = false;
      ip_record = new ip_record();
      this.to_be_deleted= to_be_deleted;
      this.ip_file = ip_file;
      setLayout(new GridLayout(4,2,10,15));
      setBackground(Color.lightGray);
      setForeground(Color.black);
      Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
      setFont(f);
      
      l0 = new Label("IP/IO Identifier");
      l1 = new Label("Number of Ports");
      try
      { 
       for( k =count; k<=position;k++)
        {
          ip_file.seek((long) k*(ip_class.object_size));
          ip_record.read(ip_file);
          if(to_be_deleted.equals(ip_record.getIdentifier().trim()))
           {
             f0 = new TextField(ip_record.getIdentifier().trim());
             f1 = new TextField(String.valueOf(ip_record.getPorts()));
             break;                       
           }
        }
      }
      catch (IOException e)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }
       if(delete == true)
        {
          f0.setEditable(false);
          f1.setEditable(false);
        }           

      Delete = new Button("Delete?");
      Modify = new Button("Modify?");
      Cancel = new Button("Cancel");
      add(l0); 
      add(f0);
      add(l1); 
      add(f1);
      if(delete==true)
      {
        add(Delete);
        Delete.addActionListener(this);
      }
      else
      { 
        add(Modify);
        Modify.addActionListener(this);
      }
      add(Cancel);

      // register it to receive those events 

      Cancel.addActionListener(this);
    
      FIP_MyWindowAdapter adapter = new FIP_MyWindowAdapter(this);
      addWindowListener(adapter);
  }  
  public void actionPerformed(ActionEvent ae)
  {
     if (ae.getSource() == Delete)
       {
         try
         {
              ip_record.setIdentifier(new String("Deleted"));
              ip_file.seek((long) (k)*(ip_class.object_size));
              ip_record.write(ip_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
             ip_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
     else if (ae.getSource() == Modify)
       {
         try
         {
              ip_record.setIdentifier(f0.getText());
              ip_record.setPorts(Double.valueOf(f1.getText()).doubleValue());
              ip_file.seek((long) (k)*(ip_class.object_size));
              ip_record.write(ip_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
              ip_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
        else if(ae.getSource() == Cancel)
          {
              setVisible(false);
          }
 }
public void paint(Graphics g)
{
 
}
}
