import java.awt.event.*;
import java.awt.*;
import java.applet.*;
import java.io.*;


public class file_to_memory_form extends Frame implements ActionListener 
{
     Label l0,l1,l2,l3,l4,l5;
     TextField f0,f1,f2,f3,f4,f5;
     private RandomAccessFile memory_file;
     Button Delete,Modify,Cancel;
     private String  to_be_deleted;
     private boolean  delete;
     private int  k;
     private memory_record m_record;

public file_to_memory_form(String title,String to_be_deleted,RandomAccessFile  memory_file,int count,int position) 
   {
      super(title);
      if(title.startsWith("Del"))
      {
        delete = true;
      }
      else
        delete = false;
      m_record = new memory_record();
      this.to_be_deleted= to_be_deleted;
      this.memory_file = memory_file;
      setLayout(new GridLayout(8,2,10,15));
      setBackground(Color.lightGray);
      setForeground(Color.black);
      Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
      setFont(f);
      
      l0 = new Label("Memory Identifier");
      l1 = new Label("Memory Size in MB:");
      l5 = new Label("Memory Bandwidth in MBPS");
      l2 = new Label("Memory Cycle Time in ns:");
      l3 = new Label("Memory Access Time in ns:");
      l4 = new Label("Interleaving, if any: ");
      
      try
      { 
       for( k =count; k<=position;k++)
        {
          memory_file.seek((long) k*(memory_class.object_size));
          m_record.read(memory_file);
          if(to_be_deleted.equals(m_record.getIdentifier().trim()))
           {
             f0 = new TextField(m_record.getIdentifier().trim());
             f1 = new TextField(String.valueOf(m_record.getSize()));
             f5 = new TextField(String.valueOf(m_record.getBw()));
             f2 = new TextField(String.valueOf(m_record.getCycle_time()));
             f3 = new TextField(String.valueOf(m_record.getAccess_time()));
             f4 = new TextField(String.valueOf(m_record.getInterleaving()));
             break;                                      
           }
        }
      }
      catch (IOException e)
      {
        System.err.println("2:from ftom  File not opened properly\n");
        System.exit(1);
      }
       if(delete == true)
        {
          f0.setEditable(false);
          f1.setEditable(false);
          f5.setEditable(false);
          f2.setEditable(false);
          f3.setEditable(false);
          f4.setEditable(false);
        }                                

      Delete = new Button("Delete?");
      Modify = new Button("Modify?");
      Cancel = new Button("Cancel");
      add(l0); 
      add(f0);
      add(l1); 
      add(f1);
      add(l5);
      add(f5);
      add(l2); 
      add(f2);
      add(l3); 
      add(f3);
      add(l4); 
      add(f4);
      if(delete==true)
      {
        add(Delete);
        Delete.addActionListener(this);
      }
      else
      { 
        add(Modify);
        Modify.addActionListener(this);
      }
      add(Cancel);

      // register it to receive those events 

      Cancel.addActionListener(this);
    
      FM_MyWindowAdapter adapter = new FM_MyWindowAdapter(this);
      addWindowListener(adapter);
  }  
  public void actionPerformed(ActionEvent ae)
  {
     if (ae.getSource() == Delete)
       {
         try
         {
              m_record.setIdentifier(new String("Deleted"));
              memory_file.seek((long) (k)*(memory_class.object_size));
              m_record.write(memory_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
              memory_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
     else if (ae.getSource() == Modify)
       {
         try
         {
              m_record.setIdentifier(f0.getText());
              m_record.setSize(Double.valueOf(f1.getText()).doubleValue());
              m_record.setBw(Double.valueOf(f5.getText()).doubleValue());
              m_record.setCycle_time(Double.valueOf(f2.getText()).doubleValue());
              m_record.setAccess_time(Double.valueOf(f3.getText()).doubleValue());
              m_record.setInterleaving(Integer.parseInt(f4.getText()));
              memory_file.seek((long) (k)*(memory_class. object_size));
              m_record.write(memory_file);
          }
          catch (IOException e)
          {
              System.err.println("2:from ftom  File not opened properly\n");
              System.exit(1);
          }
          try
          {
              memory_file.close();
          }
          catch (IOException e)
          {
              System.err.println("File not closed  properly\n");
              System.exit(1);
          }
           setVisible(false);
       }
        else if(ae.getSource() == Cancel)
          {
              setVisible(false);
          }
 }
public void paint(Graphics g)
{
 
}
}
