import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class modify_itc extends Frame implements ActionListener
 {
   private Label l0,l1,l2,l3;
   private TextField f0,f1,f2,f3;
   private Button Clear, Modify,Cancel,Add;
   private Module_List m_list;
   private int index, index_itc;
   task_class task_object;


   public modify_itc(int index,int index_itc,task_class task_object, Module_List m_list)
   {
        super("Modify an ITC entry. ");
        this.task_object = task_object;
        this.m_list = m_list;
        this.index = index;
        this.index_itc = index_itc;
        setLayout(new GridLayout(7,2,5,10));
        Font f = new Font("Serif",Font.BOLD+Font.PLAIN,15);
        setFont(f);
        l0 = new Label("Choose Channel");
        l1 = new Label("Task Name ");
        l2 = new Label("Size of Data in KB");
        l3 = new Label("Mode :  OUT(1)");
        if (index_itc !=0)
        {
          f0 = new TextField(""+task_object.channels);
          f1 = new TextField(""+task_object.identifier);
          f2 = new TextField(""+task_object.amount_of_data);
          f3 = new TextField(""+task_object.flag);
          System.out.println("Index is 0 , called in modify_itc");
        }
        else
        {
          f0 = new TextField();
          f1 = new TextField();
          f2 = new TextField();
          f3 = new TextField();
        }
                 
        Clear = new Button("Clear");
        Cancel  = new Button("Cancel");
        Modify  = new Button("Modify?");
        Add  = new Button("Add?");

        add(l0);
        add(f0);
        add(l1);
        add(f1);
        add(l2);
        add(f2);
        add(l3);
        add(f3);
        add(Clear);
        if(index_itc==0)  /* Add a new ITC entry */
          add(Add);
        else
          add(Modify);
        add(Cancel);

        f0.addActionListener(this);
        f1.addActionListener(this);
        f2.addActionListener(this);
        f3.addActionListener(this);
        Clear.addActionListener(this);
        Modify.addActionListener(this);
        Cancel.addActionListener(this);
        Add.addActionListener(this);
      
        TITC_MyWindowAdapter adapter = new TITC_MyWindowAdapter(this);
        addWindowListener(adapter);

  }

public void actionPerformed(ActionEvent ae)
 {
   if (ae.getSource()==Clear)
    {
       f0.setText("");
       f1.setText("");
       f2.setText("");
       f3.setText("");
    }
    else if (ae.getSource() == Modify)
    {
      task_object.channels = Integer.parseInt(f0.getText().trim());
      task_object.identifier = f1.getText().trim();
      task_object.amount_of_data = Double.valueOf(f2.getText()).doubleValue();
      task_object.flag = Integer.parseInt(f3.getText());
      m_list.update_itc(index,index_itc,task_object);
      setVisible(false);
    }
    else if(ae.getSource() == Add)
    {
      task_object.channels = Integer.parseInt(f0.getText());
      task_object.identifier = f1.getText().trim();
      task_object.amount_of_data = Double.valueOf(f2.getText()).doubleValue();
      task_object.flag = Integer.parseInt(f3.getText());
      m_list.addnew_itc(index,task_object);
      setVisible(false);
    }    
    else if (ae.getSource() == Cancel)
      setVisible(false);
 }       
             
}

