import java.awt.*;
import java.awt.event.*;
import java.applet.*;

public class module_itc_form extends Frame implements ActionListener ,ItemListener
{
   private Label l0,l1,l2,l3;
   private TextField f0,f1,f2,f3;
   private Button Clear, Done;
   private Choice channels;
   module_itc_form mitcf;
   task_class task_object;
   int temp;
       
   public module_itc_form(task_class task_object,int temp)
   {
        super("The TASK-ITC  Characteristics");
        this.task_object = task_object;
        this.temp = temp;
        setLayout(new GridLayout(7,2,5,10));
        Font f = new Font("Serif",Font.BOLD+Font.PLAIN,15);
        setFont(f);

        channels = new Choice();
        for(int i=1;i<=temp;i++)
         channels.add(String.valueOf(i));
        
        l0 = new Label("Choose a  Channel");
        l1 = new Label("Task Name ");
        l2 = new Label("Size of Data in KB");
        l3 = new Label("Mode :  OUT(1)");
     
        f1 = new TextField(25);
        f2 = new TextField(10);
        f3 = new TextField(10);

        Clear = new Button("Clear");
        Done  = new Button("Submit");
      
        add(l0);
        add(channels);
        add(l1);
        add(f1);
        add(l2);
        add(f2);
        add(l3);
        add(f3);
        add(Clear);
        add(Done);

        channels.addItemListener(this);
        f1.addActionListener(this);
        f2.addActionListener(this);
        f3.addActionListener(this);
        Clear.addActionListener(this);
        Done.addActionListener(this);
      
        TITC_MyWindowAdapter adapter = new TITC_MyWindowAdapter(this);
        addWindowListener(adapter);

  }

public void actionPerformed(ActionEvent ae)
 {
   if (ae.getSource()==Clear)
    {
       f1.setText("");
       f2.setText("");
       f3.setText("");
    }
    else if (ae.getSource() == Done)
    {
      task_object.identifier = f1.getText().trim();
      task_object.amount_of_data = Double.valueOf(f2.getText()).doubleValue();
      task_object.flag = Integer.parseInt(f3.getText().trim());
      setVisible(false);
    }
 }       
 public void itemStateChanged(ItemEvent ae)
 {
   if(ae.getSource() == channels)
    {
       task_object.channels = Integer.parseInt(channels.getSelectedItem().trim());
    }
 }

}

