import java.awt.event.*;
import java.awt.*;
import java.applet.*;

public class processor_pentform extends Frame  
{
     Label l0,l1,l2,l3,l4,l5;
     TextField f0,f1,f2,f3,f4;
     Button Done;
     Button Clear;
     Choice Cache;
     processor_class processor_object; 

   processor_pentform(String title) 
   {
      super(title);
      setLayout(new GridLayout(8,2,10,15));
      setBackground(Color.lightGray);
      setForeground(Color.black);
      Font f = new Font("Serif",Font.PLAIN+Font.BOLD,15);
      setFont(f);
      l0 = new Label("Processor");
      l1 = new Label("Performance Rate in MIPS");
      l4 = new Label("Memory Connection ");
//      l2 = new Label("No of Memory References / intsruction");
      l5 = new Label("Mem. ref width in bytes");
      l3 = new Label("Cache, if there is any ");
      Done = new Button("Submit");
      Clear = new Button("Clear");
      Cache = new Choice();
      Cache.add("Primary Cache");
//      Cache.add("Secondary Cache");
      

      f0 = new TextField(15);
      f0.setText("Pentium ");
      f1 = new TextField(5);
      f2 = new TextField(5);
      f3 = new TextField(15);
      f4 = new TextField(10);

      add(l0); 
      add(f0);
      add(l1); 
      add(f1);
      add(l4);
      add(f3);
    //  add(l2); 
    //  add(f2);
      add(l5);
      add(f4);
      add(l3); 
      add(Cache);
      add(Clear);
      add(Done);
      processor_object = new processor_class();

      PN_MyTextHandler handler = new PN_MyTextHandler(this);

      // register it to receive those events 

      Done.addActionListener(handler);
      Clear.addActionListener(handler);
      Cache.addItemListener(handler);

      PM_MyWindowAdapter adapter = new PM_MyWindowAdapter(this);
      addWindowListener(adapter);
  }  
}
